
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Apache Flink源码解析之stream-sink / iVAN</title>

    <meta name="description" content="Apache Flink源码解析之stream-sink 上一篇我们谈论了Flink stream source,它作为流的数据入口是整个DAG(有向无环图)拓扑的起点.那么与此对应的,流的数据出口就是跟source对应的Sink.这是我们本篇解读的内容. SinkFunction 跟SourceFunction对应,Flink针对Sink的根接口被称为SinkFunction.继承自Function这一标记接口.SinkFunction接口只提供了一个方法: void invoke(IN value) throws Exception; 该方法提供基">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Apache Flink源码解析之stream-sink</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>上一篇我们谈论了Flink stream<br />
source，它作为流的数据入口是整个DAG（有向无环图）拓扑的起点。那么与此对应的，流的数据出口就是跟source对应的<strong>Sink</strong>。这是我们本篇解读的内容。</p>
<h1>SinkFunction</h1>
<p>跟<code>SourceFunction</code>对应，Flink针对Sink的根接口被称为<code>SinkFunction</code>。继承自<code>Function</code>这一标记接口。<code>SinkFunction</code>接口只提供了一个方法：</p>
<pre><code>    void invoke(IN value) throws Exception;</code></pre>
<p>该方法提供基于记录级别的调用（也就是每个被输出的记录都会调用该接口一次）。上面方法的参数<code>value</code>即为需要输出的记录。</p>
<p><code>SinkFunction</code>相对来说比较简洁，下面我们来看一下它的实现者。</p>
<h1>内置的SinkFunction</h1>
<p>同样，我们先来看一下完整的类型继承体系：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvN3hrYWF6LmNvbTEuejAuZ2xiLmNsb3VkZG4uY29tL2ZsaW5rLXN0cmVhbS1zaW5rX2FsbC1jbGFzcy1kaWFncmFtLnBuZw==.jpg"></p>
<h2>DiscardingSink</h2>
<p>这是最简单的SinkFunction的实现，它的实现等同于没有实现（其实现为<strong><em>空方法</em></strong>）。它的作用就是将记录<strong>丢弃</strong>掉。它的主要场景应该是那些无需最终处理结果的记录。</p>
<h2>WriteSinkFunction</h2>
<p><code>WriteSinkFunction</code>是一个抽象类。该类的主要作用是将需要输出的<code>tuples</code>（元组）作为简单的文本输出到指定路径的文件中去，元组被收集到一个list中去，然后周期性得写入文件。</p>
<p><code>WriteSinkFunction</code>的构造器接收两个参数：</p>
<ul>
<li>path : 需要写入的文件路径</li>
<li>format : <code>WriteFormat</code>的实例，用于指定写入数据的格式</li>
</ul>
<p>在构造器中，它调用方法<code>cleanFile</code>，该方法用于初始化指定path的文件。初始化的行为是：<strong><em>如果不存在则创建，如果存在则清空</em></strong>。</p>
<p>invoke方法的实现：</p>
<pre><code>    public void invoke(IN tuple) {

        tupleList.add(tuple);
        if (updateCondition()) {
            format.write(path, tupleList);
            resetParameters();
        }

    }</code></pre>
<p>从实现来看，其先将需要sink的元组加入内部集合。然后调用<code>updateCondition</code>方法。该方法是<code>WriteSinkFunction</code>定义的抽象方法。用于实现判断将tupleList写入文件以及清空tupleList的条件。接着将集合中的tuple写入到指定的文件中。最后又调用了<code>resetParameters</code>方法。该方法同样是一个抽象方法，它的主要用途是当写入的场景是批量写入时，可能会有一些状态参数，该方法就是用于对状态进行reset。</p>
<h3>WriteSinkFunctionByMillis</h3>
<p>该类是<code>WriteSinkFunction</code>的实现类。它支持以指定的毫秒数间隔将tuple批量写入文件。间隔由构造器参数<code>millis</code>指定。在内部，<code>WriteSinkFunction</code>以<code>lastTime</code>维护上一次写入的时间状态。它主要涉及上面提到的两个抽象方法的实现：</p>
<pre><code>    protected boolean updateCondition() {
        return System.currentTimeMillis() - lastTime &gt;= millis;
    }</code></pre>
<p><code>updateCondition</code>的实现很简单，拿当前主机的当前时间戳跟上一次的执行时间戳状态作对比：如果大于指定的间隔，则条件为真，触发写入。</p>
<pre><code>    protected void resetParameters() {
        tupleList.clear();
        lastTime = System.currentTimeMillis();
    }</code></pre>
<p><code>resetParameters</code>实现是先清空tupleList，然后将lastTime老的时间戳状态覆盖为最新时间戳。</p>
<h3>WriteFormat</h3>
<p>一个写入格式的抽象类，提供了两种实现：</p>
<ul>
<li>WriteFormatAsText ： 以原样文本的形式写入指定路径的文件</li>
<li>WriteFormatAsCsv ： 以csv格式写入指定文件</li>
</ul>
<h2>RichSinkFunction</h2>
<p><code>RichSinkFunction</code>通过继承<code>AbstractRichFunction</code>为实现一个<strong>rich</strong><br />
SinkFunction提供基础(<code>AbstractRichFunction</code>提供了一个open/close方法对，以及获取运行时上下文对象手段)。<code>RichSinkFunction</code>也是抽象类，它有三个具体实现。</p>
<h3>SocketClientSink</h3>
<p>支持以socket的方式将数据发送到特定目标主机所在的服务器作为flink stream的sink。数据被序列化为byte<br />
array然后写入到socket。该sink支持<strong><em>失败重试</em></strong>模式的消息发送。该sink<br />
可启用<code>autoFlush</code>，如果启用，那么会导致吞吐量显著下降，但延迟也会降低。该方法的构造器，提供的参数：</p>
<ul>
<li>hostName ： 待连接的server的host name</li>
<li>port ： server的端口</li>
<li>schema ：<code>SerializationSchema</code>的实例，用于序列化对象。</li>
<li>maxNumRetries ： 最大重试次数（-1为无限重试）</li>
<li>autoflush ： 是否自动flush</li>
</ul>
<p>重试的策略在<code>invoke</code>方法中，当发送失败时进入到异常捕捉块中进行。</p>
<h3>OutputFormatSinkFunction</h3>
<p>一个将记录写入<code>OutputFormat</code>的SinkFunction的实现。</p>
<blockquote><p>OutputFormat ：定义被消费记录的输出接口。指定了最终的记录如何被存储，比如文件就是一种存储实现。</p></blockquote>
<h3>PrintSinkFunction</h3>
<p>该实现用于将每条记录输出到标准输出流（stdOut）或标准错误流(stdErr)。在输出时，如果当前task的并行subtask实例个数大于1，也就是说当前task是并行执行的（同时存在多个实例），那么在输出每条记录之前会输出一个<code>prefix</code>前缀。prefix为在全局上下文中当前subtask的位置。</p>
<h1>常见连接器中的Sink</h1>
<p>Flink自身提供了一些针对第三方主流开源系统的连接器支持，它们有：</p>
<ul>
<li>elasticsearch</li>
<li>flume</li>
<li>kafka(0.8/0.9版本)</li>
<li>nifi</li>
<li>rabbitmq</li>
<li>twitter</li>
</ul>
<p>这些第三方系统（除了twitter）的sink，无一例外都是继承自<code>RichSinkFunction</code>。</p>
<h1>小结</h1>
<p>这篇文章我们主要谈及了Flink的stream sink相关的设计、实现。当然这个主题还没有完全谈完，还会有后续篇幅继续解读。</p>
<p>原文发布时间为：2016-05-07</p>
<p>本文作者：vinoYang</p>
<p>本文来自合作伙伴<a href="http://blog.csdn.net/yanghua_kobe/article/details/51367641" rel="external nofollow noreferrer">CSDN博客</a>，了解相关信息可以关注CSDN博客。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-24 13:49:24</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/apache/" title="apache">apache</a>, <a href="https://www.iamivan.net/tag/%e4%ba%91%e6%a0%96%e7%a4%be%e5%8c%ba/" title="云栖社区">云栖社区</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.iamivan.net/tag/stream/" title="stream">stream</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Apache Flink源码解析之stream-sink的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8vQRb.html" rel="bookmark">Apache Flink源码解析之stream-window</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				window(窗口)是Flink流处理中非常重要的概念,本篇我们来对窗口相关的概念以及关联的实现进行解析.本篇的内容主要集中在package org.apache.flink.streaming.api.windowing下. Window 一个Window代表有限对象的集合.一个窗口有一个最大的时间戳,该时间戳意味着在其代表的某时间点--所有应该进入这个窗口的元素都已经到达. Flink的根窗口对象是一个抽象类,只提供了一个抽象方法: public abstract long maxTimes			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWRyRb.html" rel="bookmark">Apache Flink源码解析之stream-source</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天我们来解读一下Flink stream里的source模块.它是整个stream的入口,也是我们了解其流处理体系的入口. SourceFunction SourceFunction是所有stream source的根接口. 它继承自一个标记接口(空接口)Function. SourceFunction定义了两个接口方法: run : 启动一个source,即对接一个外部数据源然后emit元素形成stream(大部分情况下会通过在该方法里运行一个while循环的形式来产生stream). ca			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGA00kM.html" rel="bookmark">Apache Flink源码解析之stream-windowfunction</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Window也即窗口,是Flink流处理的特性之一.前一篇文章我们谈到了Winodw的相关概念及其实现.窗口的目的是将无界的流转换为有界的元素集合,但这还不是最终的目的,最终的目的是在这有限的集合上apply(应用)某种函数,这就是我们本篇要谈的主题--WindowFunction(窗口函数). 那么窗口函数会在什么时候被应用呢?还记得上篇文章我们谈到了触发器Trigger,在触发器触发后会返回TriggerResult这个枚举类型的其中一个枚举值.当返回的是FIRE或者FIRE_AND_PUR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMg2m3b.html" rel="bookmark">Java集合学习（十二） TreeMap详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一章,我们对TreeMap进行学习. 第1部分 TreeMap介绍 TreeMap 简介 TreeMap 是一个有序的key-value集合,它是通过红黑树实现的. TreeMap继承于AbstractMap,所以它是一个Map,即一个key-value集合. TreeMap 实现了NavigableMap接口,意味着它支持一系列的导航方法.比如返回有序的key集合. TreeMap 实现了Cloneable接口,意味着它能被克隆. TreeMap 实现了java.io.Serializabl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeaxxjz.html" rel="bookmark">Java 集合系列12之 TreeMap详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概要 这一章,我们对TreeMap进行学习.我们先对TreeMap有个整体认识,然后再学习它的源码,最后再通过实例来学会使用TreeMap.内容包括:第1部分 TreeMap介绍第2部分 TreeMap数据结构第3部分 TreeMap源码解析(基于JDK1.6.0_45)第4部分 TreeMap遍历方式第5部分 TreeMap示例 转载请注明出处:http://www.cnblogs.com/skywang12345/admin/EditPosts.aspx?postid=3310928   第			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmjXe7z.html" rel="bookmark">Step&period;js 使用教程（附源码解析）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Step.js(https://github.com/creationix/step)是控制流程工具(大小仅 150 行代码),解决回调嵌套层次过多等问题.适用于读文件.查询数据库等回调函数相互依赖,或者分别获取内容最后组合数据返回等应用情景.异步执行简单地可以分为&quot;串行执行&quot;和&quot;并行&quot;执行,下面我们分别去看看. 串行执行 这个库只有一个方法 Step(fns...).Step 方法其参数 fns 允许是多个函数,这些函数被依次执行.Step 利用 this 对象指			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Xpmv3az.html" rel="bookmark">Java集合学习（十七） TreeSet详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一章,我们对TreeSet进行学习. 我们先对TreeSet有个整体认识,然后再学习它的源码,最后再通过实例来学会使用TreeSet. 第1部分 TreeSet介绍 TreeSet简介 TreeSet 是一个有序的集合,它的作用是提供有序的Set集合.它继承于AbstractSet抽象类,实现了NavigableSet&lt;E&gt;, Cloneable, java.io.Serializable接口. TreeSet 继承于AbstractSet,所以它是一个Set集合,具有Set的属性和方法.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lpdw03M.html" rel="bookmark">Java集合学习（十六） HashSet详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一章,我们对HashSet进行学习. 我们先对HashSet有个整体认识,然后再学习它的源码,最后再通过实例来学会使用HashSet. 第1部分 HashSet介绍 HashSet 简介 HashSet 是一个没有重复元素的集合. 它是由HashMap实现的,不保证元素的顺序,而且HashSet允许使用 null 元素. HashSet是非同步的.如果多个线程同时访问一个哈希 set,而其中至少一个线程修改了该 set,那么它必须 保持外部同步.这通常是通过对自然封装该 set 的对象执行同步			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp51VAp.html" rel="bookmark">Java集合学习（十三） WeakHashMap详细介绍&lpar;源码解析&rpar;和使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这一章,我们对WeakHashMap进行学习. 我们先对WeakHashMap有个整体认识,然后再学习它的源码,最后再通过实例来学会使用WeakHashMap. 第1部分 WeakHashMap介绍 WeakHashMap简介    WeakHashMap 继承于AbstractMap,实现了Map接口.    和HashMap一样,WeakHashMap 也是一个散列表,它存储的内容也是键值对(key-value)映射,而且键和值都可以是null.   不过WeakHashMap的键是&quot;弱键&			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZJOOz.html" rel="bookmark" class="title">疏密、大小对比设计作品剖析</a>
					<div>
						设计 人们通过设计来满足需求.无论我们进行广告.标志.包装.版式等设计.还是为了创造优美的生活工作环境而进行的平面艺术设计,无一例外地都会涉及画面的创意.构成和表现技术等基本问题. 当我们通过视觉表现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7Djab.html" rel="bookmark" class="title">ORACLE 服務器的配置及優化</a>
					<div>
						oracle   ORACLE 服務器的配置及優化1.        在ORACLE中實現分布式快速存取和充實內存是很重要的.         要不惜任何代價避免頁面調度和交換﹐每次都必須把系統全局區 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwo8nz.html" rel="bookmark" class="title">比网站与网站之间的竞争应该提升到战略层面</a>
					<div>
						其实我经常说一个网站的经营是建立在公司经营的层面上的,一家公司的经营以及发展方向完全可以在网站上体现出来.所以一些人喜欢把自己公司的SEO外包出去,个人认为是非常不合适的,因为SEO服务公司很难去懂你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJyd8p.html" rel="bookmark" class="title">总结网页设计制作的一些通则</a>
					<div>
						相关文章:网页内容页面制作的9个实用建议 网页页面设计的4个实用建议 网页布局的9个建议 网页制作关于HTML格式和长文件的建议 网页设计关于超级链接的设计原则 通则 1.鼓励读者通过填表或发邮件反馈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5GGnb.html" rel="bookmark" class="title">C&plus;&plus;：通过私有&lpar;private&rpar;继承复用类实现工厂函数详解</a>
					<div>
						通过接口类(interface class), 实现工厂函数, 可以复用(reuse)已有类, 重写实现接口. 如: 接口类: IPerson; 复用类: PersonInfo; 实现类: CPers ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3OP7b.html" rel="bookmark" class="title">再学GDI&plus;&lbrack;7&rsqb;&colon; DrawLines</a>
					<div>
						本例效果图: 代码文件:unit Unit1; interface uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKQk6p.html" rel="bookmark" class="title">搜狗输入法怎样进行中英文切换输入</a>
					<div>
						输入法默认是按下&quot;Shift&quot;键就切换到英文输入状态,再按一下&quot;Shift&quot;键就会返回中文状态.用鼠标点击状态栏上面的中字图标也可以切换. 除了&quot;Sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP86Gz.html" rel="bookmark" class="title">Win7系统宽带连接无法连接提示错误代码1717怎么解决？</a>
					<div>
						  Win7系统宽带连接无法连接提示错误代码1717怎么解决? 1.按下&quot;Win+R&quot;组合键呼出运行,输入&quot;services.msc&quot;按下回车键打开&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze43Q9p.html" rel="bookmark" class="title">如何用php查看邮件是否已被阅读？</a>
					<div>
						       当你在发送邮件时,你或许很想知道该邮件是否被对方已阅读,下面有段不错的代码可以实现此需求,喜欢的朋友可以参考下  代码如下: &lt;?  error_reporting(0);  He ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7OyVb.html" rel="bookmark" class="title">javascript解析json实例详解</a>
					<div>
						 php生成json格式 使用页面    代码如下: &lt;script src=&quot;scripts/json.js&quot;&gt;&lt;/script&gt;  alert(data ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8lVYb.html" rel="bookmark" class="title">搭建docker内网私服（docker-registry with nginx&amp;amp&semi;ssl on centos）</a>
					<div>
						1. Docker Registry 说明 关于如何创建和使用本地仓库,其实已经有很多文章介绍了.因为docker技术正处于发展和完善阶段,所以有些文章要么内容已经过时,要么给出了错误的配置,导致无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24vZQp.html" rel="bookmark" class="title">字符串-关于C&plus;&plus;  string 的问题</a>
					<div>
						问题描述 关于C++ string 的问题 10C 实现C++ string中一个函数函数形式为replace(S1,i,jS2)S1是string对象,i表示从S1对象的i位置开始删除长度为j的字符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa9nLz.html" rel="bookmark" class="title">移动开发iOS&amp;amp&semi;Android对比学习--异步处理</a>
					<div>
						在移动开发里很多时候需要用到异步处理.Android的主线程如果等待超过一定时间的时候直接出现ANR(对不熟悉Android的朋友这里需要解释一下什么叫ANR.ANR就是Application Not ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoAmPb.html" rel="bookmark" class="title">android-机顶盒上面的软键盘怎么隐藏，在代码中是用的键盘隐藏方法在机顶盒上面没有反应</a>
					<div>
						问题描述 机顶盒上面的软键盘怎么隐藏,在代码中是用的键盘隐藏方法在机顶盒上面没有反应 机顶盒上面的软键盘怎么隐藏,在代码中是用的键盘隐藏方法在机顶盒上面没有反应,可是在 手机上面显示就行,这是什么情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRQK3z.html" rel="bookmark" class="title">网络子系统13&lowbar;邻居子系统状态机</a>
					<div>
						// 参考深入理解linux网络技术内幕 // 头文件net/neighbour.h //一个solicitation请求已发出,但是还没有收到应答,在这个状态下,不适用任何硬件地址 #define  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqxe3b.html" rel="bookmark" class="title">青年人在武汉创业将更方便</a>
					<div>
						从武汉http://www.aliyun.com/zixun/aggregation/31845.html&quot;&gt;青年创业工作推进会上获悉,武汉已聘请青年创业导师志愿者98人,并成立武汉青 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZ7Dob.html" rel="bookmark" class="title">Java Fork Join 框架（三）实现</a>
					<div>
						这个框架是由大约800行纯Java代码组成,主要的类是FJTaskRunner,它是java.lang.Thread的子类.FJTasks 自己仅仅维持一个关于结束状态的布尔值,所有其他的操作都是通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPw48p.html" rel="bookmark" class="title">异构系统，如何实现数据双向同步</a>
					<div>
						问题描述 异构系统,如何实现数据双向同步 目前在做老系统的重新工作,目前已经完成了新系统的开发. 但是两个系统需要并存上线一段时间,两边都有可能有查询和修改数据的操作,新老系统的底层数据库结构设计不同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N33az.html" rel="bookmark" class="title">fatal error C1004&colon; unexpected end of file found</a>
					<div>
						问题描述 fatal error C1004: unexpected end of file found #include #include #include #define N 100 #defin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDexL6b.html" rel="bookmark" class="title">中小企业SaaS产品和服务该如何选择</a>
					<div>
						试用产品.选择厂商.评估安全.确认价格.确认合约,是企业选择SaaS的重要方面. 一.试用产品很重要 一般SaaS服务商都会给出一定时间(一般是一个月)的免费试用,通过试用,企业用户不仅可以了解的Sa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZvxAp.html" rel="bookmark" class="title">matlab的多目标遗传算法</a>
					<div>
						问题描述 有谁做过多目标遗传算法吗?可以交流下! 解决方案 解决方案二:http://bbs.csdn.net/topics/360218420					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe730b.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;上如何进行大整数运算</a>
					<div>
						问题描述 C++上如何进行大整数运算 C++上如何进行大整数运算,特别是关于大整数的幂次取模运算的算法 解决方案 大整数运算C++ 大整数运算---------------------- 解决方案二: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoqL0M.html" rel="bookmark" class="title">母婴电商Baby&period;com&period;br获千万美元融资 迎合巴西中产阶级</a>
					<div>
						近日,据相关媒体报道,母婴产业能产生年均1000亿的市场空间.巴西在线母婴用品商店Baby.com.br获得由Accel Partner主投,Tiger Global参与投资的B轮融资,融资额约为16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwPB5M.html" rel="bookmark" class="title">编程-极坐标到直角坐标转换  matlab</a>
					<div>
						问题描述 极坐标到直角坐标转换 matlab 这是两幅心血管的超声图像,第一幅是我以下面一幅图像的图心做的极坐标变换,现在的问题是如何从极坐标图像编程还原回第二幅图呢,第一幅图大小192*360,第二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZRP7z.html" rel="bookmark" class="title">《卫报》：沉睡十年 微软大梦初醒</a>
					<div>
						[导读]过去十年当中,网络搜索.在线广告以及智能手机都没有受到微软的重视. 1986年的比尔·盖茨和微软第一部笔记本电脑(腾讯科技配图) 北京时间7月22日消息,国外知名媒体&lt;卫报&gt;网络版 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYZ86b.html" rel="bookmark" class="title">自动化收集SQLSERVER诊断信息的工具选择及使用介绍&lowbar;MsSql</a>
					<div>
						自动化收集SQLSERVER诊断信息 相信很多人都遇到过当SQLSERVER出现问题的时候,而你又解决不了需要DBA或者微软售后支持工程师去帮忙解决问题,那么他们一般需要你收集一些系统信息和SQLSE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GV2op.html" rel="bookmark" class="title">js复制内容到剪贴板代码&comma;js复制代码的简单实例&lowbar;javascript技巧</a>
					<div>
						如下所示: &lt;script type=&quot;text/JavaScript&quot;&gt; function jsCopy(){ var e=document.getElementBy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6XgJM.html" rel="bookmark" class="title">windows-guacamole 配置完出现错误</a>
					<div>
						问题描述 guacamole 配置完出现错误 出现server error 问题 在自己电脑上测试的,windows8.1系统 装了虚拟机运行ubuntu系统,用windows访问linux系统 ,配 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPE85p.html" rel="bookmark" class="title">踏踏实实做事 认认真真做人</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 四年的时间悄悄地流逝了.创办晶石道,是一个很偶然的机会,让我在2003年重拾大学里互联网的梦想. 大家都知道1998-2000年间的互联网泡沫让 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2j6Bz.html" rel="bookmark" class="title">去哪儿网TTS打造新秩序</a>
					<div>
						过去,去哪儿网(qunar.com)身上的标签是&quot;垂直旅游行业的百度&quot;,业务模式是CPC(搜索比价);现在,去哪儿网将标签换为&quot;垂直旅游行业的百度+淘宝&quot;,业务 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
